#include "Sct/ISSerializableWrapper.h"
#include "Sct/IOManager.h"
#include "SerializableWrappers.h"
#include <sstream>

namespace SctArchiving{

void Sct::ISSerializableWrapper<TestData>::constructUniqueID() const{
  std::ostringstream uniqueid;
  uniqueid << getWrappedObject()->runNumber << "."
	   << getWrappedObject()->startScanNumber << "."
	   << getWrappedObject()->testName;
  m_uniqueID=uniqueid.str();
}

void Sct::ISSerializableWrapper<SequenceData>::constructUniqueID() const{
  std::ostringstream uniqueid;
  uniqueid << getWrappedObject()->runNumber << "."
	   << getWrappedObject()->startScanNumber << "."
	   << getWrappedObject()->sequenceName;
  m_uniqueID=uniqueid.str();
}
  
  static bool dummy1 = Sct::IOManager::addToMap("SequenceData" , std::auto_ptr<Sct::Streamer>(new Sct::ISStreamerWrapper<SequenceData>() ) ) ;
  static bool dummy2 = Sct::IOManager::addToMap("TestData", std::auto_ptr<Sct::Streamer>(new Sct::ISStreamerWrapper<TestData>() ) ) ;
}
