#ifndef SCTCALIBRATIONRUNCONTROLLER_H
#define SCTCALIBRATIONRUNCONTROLLER_H

#ifdef linux
#undef linux
#endif

#include <rc/UserRoutines.h>
#include <boost/utility.hpp>
#include <string>

using std::string;

class ISCallbackInfo;

namespace SctCalibrationController {

class CalibrationControllerImpl;

class RunControl : public RC::UserRoutines, boost::noncopyable {
public:
    enum ErrorState {
        SCTAPI_ACCESS_FAILURE
    };

    static RunControl& instance();

    //methods associated with Alive
    //  virtual void enterAlive();
    //virtual void exitAlive();
    //  virtual void killaction ();
    virtual bool resetAction ();

    //methods associated to Initial
    //  virtual void enterInitial();
    //  virtual void exitInitial();
    /**
      Get hold of SctApi and pass it to the CalibrationController
      
      */
    virtual bool loadAction ();
    //virtual void terminateaction ();

    //methods associated with Active
    //virtual void enterActive();
    //  virtual void exitActive();
    //  virtual int stopaction ();

    //methods associated with Running
    virtual bool prepareAction();

    virtual bool stopEFAction();

    //  virtual int pauseaction ();

    //methods associated with Paused
    //  virtual void enterPaused();
    //  virtual void exitPaused();
    //  virtual int stepaction ();
    //  virtual int resumeaction ();

    //methods associated with Configured
    //virtual void enterConfigured();
    //  virtual void exitConfigured();
    //virtual int unconfigaction();

    // ?? What has this become?? (LESTER) virtual int startAction ();

    //methods associated with Loaded
    //  virtual void enterLoaded();
    //  virtual void exitLoaded();
    virtual bool unloadAction ();
    virtual bool configureAction ();

    /**
      Call this to indicate an error accessing the api
      */
    void sctApiError(/*ErrorState state, */const string& reason);
private:
    int getRunNumber();
    RunControl();
    CalibrationControllerImpl& cc;
    Sct_SctApi::SctApiIPC_var api;
    boost::shared_ptr<ISInfoDictionary> m_isInfoDictionary;
 public:
    static const int defaultRunNumber = 0;
};

}

#endif //SCTCALIBRATIONRUNCONTROLLER_H
