#ifndef SCTCALIBRATIONCONTROLLER_NMASKTEST_H
#define SCTCALIBRATIONCONTROLLER_NMASKTEST_H

#include "../ipc/TestRequest.h"
#include "../ipc/CalibrationController.h"
#include "../ipc/ScanLibrary.h"
#include "../ipc/CalibrationController.hh"

#include "../SctApiAccessException.h"
#include "../SctApiCall.h"
#include "../CalibrationControllerImpl.h"
#include "Sct/LogicErrors.h"

#include <CommonWithDsp/ABCD/ABCDscans.h>
#include <iostream>
#include <vector>

using namespace Sct;
using namespace std;
using namespace SctCalibrationController::Ipc;
using namespace SctCalibrationController;

namespace SctCalibrationController {
namespace Scripts {

  /** single nmask scan with checking */
    
class NMaskTest : public TestRequestImpl {
private:
   static const bool registeredInTestLibrary;

public:	
    static Sct_CalibrationController::TestRequest_ptr instance() {
	static NMaskTest rc;
	return rc._this();
    }
    
    virtual void startTestRealImpl(Sct_SctApi::SctApiIPC_ptr api, string& name, unsigned short& testVariable, unsigned long& nScans, vector<double>& testPoints) {	
	this->api = Sct_SctApi::SctApiIPC::_duplicate(api);

        // Compression mode X1X
        APICALL(api, modifyABCDVar(ST_COMPRESSION, 1), "NMaskTest::startTest")

        // Edge detect off
        APICALL(api, modifyABCDVar(ST_EDGE_DETECT, 0), "NMaskTest::startTest")

        // No masked channels
        APICALL(api, modifyABCDVar(ST_SEND_MASK, 1), "NMaskTestassTest::startTest")

	name = "NMaskTest";
	testVariable = ST_ELAPSED;
	nScans = 1;
	
	testPoints.push_back(nTriggers);
    }
    
    virtual Sct_CalibrationController::ScanRequest_ptr getNextScanRealImpl(unsigned long index) {
	Sct_CalibrationController::ScanLibrary_var sl = CalibrationControllerImpl::instance()->getScanLibrary();
	return sl->nmaskScan(nTriggers);
    }
    
    virtual bool canFeedbackRealImpl() {
	return false;
    }
    
    virtual void endTestRealImpl() {
	api = Sct_SctApi::SctApiIPC::_nil();
    }
    
private:
    NMaskTest() {}
    Sct_SctApi::SctApiIPC_var api;    
    static const int nTriggers = 100;
};
}
}
#endif //SCTCALIBRATIONCONTROLLER_NMASKTEST_H
