#ifndef SCT_FITTINGSERVICE_FITTERARGUMENTS_H
#define SCT_FITTINGSERVICE_FITTERARGUMENTS_H
#include "SctService/Arguments.h"

namespace SctFitter {
/** Command line arguments available for fitting service */
class FitterArguments : public SctService::Arguments {
 public:
  /** 
      constructor builds from command line args 
  */
  FitterArguments(int argc, char** argv);
  /**
     get FitStrategy name
  */
     std::string getStrategyName() const;
  /**
     options used by FitStrategy
  */
  std::string getFitOptions() const;
  /**
     Use analytic arguments?
  */
  bool analytic() const;
  /** 
      overload SctService::Arguments::printHelp(std::ostream)
  */
  void printHelp(std::ostream& os) const;
  /**
     overload SctService::Arguments::parse()
  */
  virtual void parse();
private:
  FitterArguments();
  std::string m_strategy;
  std::string m_options;
  bool m_analytic;
};
}

#endif
