
#include <iostream>
#include <ipc/core.h>
#include <ipc/partition.h>
#include <pmg/pmg_initSync.h>
#include <unistd.h>
#include "Sct/ApplicationStartupDebugTools.h"
#include "Sct/MultiMessageDebugStream.h"
#include "SubscriptionManagerImpl.h"
#include "Sct/SctNames.h"

using std::cout;
using std::cerr;
using std::endl;

int main(int argc, char * argv[]) {
  IPCCore::init(argc, argv);
  Sct::ApplicationStartupDebugTools::announceStartOfMain(argc, argv, __FILE__, __LINE__);
  
  IPCPartition p(Sct::SctNames::getPartitionName());
  if (!(p.isValid())) {
    Sct::MultiMessageDebugStream m;
    m << "Could not get SCT partition.  Probably you have not started one, or even worse have not even started a root partition.  Try:\n     ipc_server &\n     sleep 2\n     ipc_server -p SCT &";
    m.flush();
    return 1;
  };

  // now actually make the object that people will see via ipc methods:
  Sct::SubscriptionManagerImpl & subscriptionManager 
    = Sct::SubscriptionManagerImpl::instance();

  //subscriptionManager.startCatchingSignals();
  subscriptionManager.publish();
  pmg_initSync();
  subscriptionManager.run(); // blocks till shutdown() or shutdownNOW() are called!
};
