#include "Name_Test.h"
#include "../src/Archive/IONameArchiveFile.h"
#include "../src/SctNames.h"

#include <boost/test/unit_test.hpp>

using boost::unit_test_framework::test_suite;

namespace Sct {

  void testIONameArchFile1(){
    Archive::IONameArchiveFile name(UniqueID("1.13.mymodule"),"CLASSNAME");
    BOOST_CHECK_EQUAL((string)name.getUniqueID(), 
		      (string)UniqueID(1,13,"mymodule"));
    BOOST_CHECK(name.getUniqueID()==UniqueID("1.13.mymodule"));
    BOOST_CHECK_EQUAL(name.getClassName(), "CLASSNAME");
    string expected_name=SctNames::getPersistentDir();
    expected_name+="/CLASSNAME.1.13.mymodule.gz";
    BOOST_CHECK_EQUAL(name.getIOName(), expected_name);
  }
  void testIONameArchFile2(){
    Archive::IONameArchiveFile name("SctData::RawScanResult.551.44.20220330200020.gz");
    BOOST_CHECK_EQUAL((string)name.getUniqueID(), "551.44.20220330200020");
    BOOST_CHECK(name.getUniqueID() == UniqueID("551.44.20220330200020"));
    BOOST_CHECK_EQUAL(name.getClassName(), "SctData::RawScanResult");
  }
      
  Name_Test::Name_Test() {
    add(BOOST_TEST_CASE(&testIONameArchFile1));
    add(BOOST_TEST_CASE(&testIONameArchFile2));
  }
}
