#ifndef SCT_FIBRE_NUMBER_CONVERTERS_H
#define SCT_FIBRE_NUMBER_CONVERTERS_H

namespace Sct {

  class FibreNumberConverters {
  public:
    // In 96 format, valid fibres are in range [0,95]
    // In 124 format, valid fibres are in range [0,123] so long as they are also in the range [0,11] modulo 16.
    static const unsigned int from124FormatTo96Format(const unsigned int zeroTo123Pos) {
	const unsigned int zeroTo95Pos = (zeroTo123Pos/16)*12 + (zeroTo123Pos%16);
	return zeroTo95Pos;
    };
    static const unsigned int from96FormatTo124Format(const unsigned int zeroTo95Pos) {
	const unsigned int zeroTo123Pos = (zeroTo95Pos/12)*16 + (zeroTo95Pos%12);
	return zeroTo123Pos;
    };
  };

};

#endif 
