#ifndef SCTDATA_IO_RXTHRESHOLDBASEDONCONFIGREGISTERTESTRESULTSTREAMER_H
#define SCTDATA_IO_RXTHRESHOLDBASEDONCONFIGREGISTERTESTRESULTSTREAMER_H

#include "TestResultStreamer_v1.h"
#include "../RxThresholdBasedOnConfigRegisterTestResult.h"

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of RxThresholdBasedOnConfigRegisterTestResult objects
 */
class RxThresholdBasedOnConfigRegisterTestResultStreamer_v1 : public Sct::Streamer {
public:
    //Streamer_v1 overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
    void writeStreamResult(OStream& out, const RxThresholdBasedOnConfigRegisterTestResult::StreamResult&, const IOManager& manager) const throw(LogicError, IoError) ;
    void readStreamResult(IStream& in, RxThresholdBasedOnConfigRegisterTestResult::StreamResult&, const IOManager& manager) const throw(LogicError, IoError) ;
    virtual unsigned getVersion() const throw() {return s_version;}
private:
    RxThresholdBasedOnConfigRegisterTestResultStreamer_v1() throw();
    static unsigned s_version;
    static bool inMap;
};
}
}

#endif // #ifndef SCTDATA_IO_RXTHRESHOLDBASEDONCONFIGREGISTERTESTRESULTSTREAMER_H
