# Possible implementation of a threepoint-gain sequence
# Defaults to running 10 times
import Sct_CalibrationController
import Sct_SctApi
import ipc

class ThreePointSequence(Sct_CalibrationController.SequenceRequestPOA):
	def __init__(self, cc, n):
                self.count = n
		tl = cc.getTestLibrary()
		self.testRequest = tl.getTestRequestByName("ThreePointGain")

	def startSequence(self, api):
		return "ThreePointSequence"

	def getNextTest(self, index):
		if index < self.count:
			return self.testRequest
		return 0

	def endSequence(self):
                pass

# SI = GuiComponents.System.SystemInterface.getInstance()
cc = SI.getCalibrationController()

seqRequest = ThreePointSequence(cc, 10)
sr = seqRequest._this(ipc.Core.getORB())

cc.doSequence(sr)
